import sys
from PIL import Image

image = Image.open('matching.png').convert('L')

offset = 354
points = [(244,190), (343,213), (388,304), (344,396), (244,422), (164, 356), (164, 255)]
points = points + points

allmasks = [[] for y in xrange(10)]
flipmasks = [[] for y in xrange(10)]

for y in xrange(10):
    for x in xrange(10):
        for flip in xrange(2):
            masks = []
            for rot in xrange(7):
                mymask = 0
                for a in xrange(7):
                    for b in xrange(7):
                        if a == b: continue
                        mymask *= 2
                        begin = (points[a+rot][0] + x*offset, points[a+rot][1] + y*offset)
                        end   = (points[b+rot][0] + x*offset, points[b+rot][1] + y*offset)
                        for rb in xrange(21):
                            re = 20 - rb
                            zz = (begin[0] * rb/20 + end[0] * re/20, begin[1] * rb/20 + end[1] * re/20)
                            if image.getpixel(zz) == 255:
                                break
                        else:
#                            if x==0 and y==0 and rot==0: print (a, b),
                            mymask += 1
                masks.append(mymask)
            (flipmasks if flip else allmasks)[y].append(masks)
            points.reverse()
#        print masks

compl = (1<<42) - 1

found = set()

for y in xrange(10):
    for x in xrange(10):
        for y2 in xrange(10):
            for x2 in xrange(10):
                if (x, y) == (x2, y2): continue
                if allmasks[y2][x2][0] in allmasks[y][x]:
                    print >>sys.stderr, 'identical', x, y, x2, y2
                    found.add((x, y, x2, y2))
                    found.add((x2, y2, x, y))
                if flipmasks[y2][x2][0] in allmasks[y][x]:
                    print >>sys.stderr, 'mirror', x, y, x2, y2
                    found.add((x, y, x2, y2))
                    found.add((x2, y2, x, y))
                if allmasks[y2][x2][0] ^ compl in allmasks[y][x]:
                    print >>sys.stderr, 'complement', x, y, x2, y2
                    found.add((x, y, x2, y2))
                    found.add((x2, y2, x, y))

assert len(found) == 6

for x, y, x2, y2 in found:
    if (x, y) > (x2, y2): continue
    print chr(65+x) + str(y), chr(65+x2) + str(y2)
